﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using AddressBookSilverlightApp.AddressBookServiceReference;
using AddressBookData;

namespace AddressBookSilverlightApp
{
    public partial class MainPage : UserControl
    {
        AddressBookServiceReference.AddressBookServiceClient service;
        public MainPage()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            service = new AddressBookServiceReference.AddressBookServiceClient();
            // デザイン時にはデータは読み込まれません。
            // if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(this))
            // {
            // 	//データをここで読み込んで、結果を CollectionViewSource に割り当てます。
            // 	System.Windows.Data.CollectionViewSource myCollectionViewSource = (System.Windows.Data.CollectionViewSource)this.Resources["Resource Key for CollectionViewSource"];
            // 	myCollectionViewSource.Source = your data
            // }
        }

        void service_GetEntriesCompleted(object sender, AddressBookServiceReference.GetEntriesCompletedEventArgs e)
        {
//            listBox1.ItemsSource = e.Result;
            dataGrid1.ItemsSource = e.Result;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            /*
            var entry = dataGrid1.SelectedItem as Entry;
            service.UpdateEntryCompleted += new EventHandler<UpdateEntryCompletedEventArgs>(service_UpdateEntryCompleted);
            service.UpdateEntryAsync(entry);
            */
            var entries = dataGrid1.ItemsSource.Cast<Entry>();
            service.UpdateEntriesCompleted += new EventHandler<UpdateEntriesCompletedEventArgs>(service_UpdateEntriesCompleted);
            service.UpdateEntriesAsync(new ObservableCollection<Entry>(entries));
        }

        void service_UpdateEntryCompleted(object sender, UpdateEntryCompletedEventArgs e)
        {
            MessageBox.Show("データ保存" + (e.Result ? "成功" : "失敗"));
        }

        void service_UpdateEntriesCompleted(object sender, UpdateEntriesCompletedEventArgs e)
        {
            MessageBox.Show("データ保存" + (e.Result ? "成功" : "失敗"));
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            service.GetEntriesCompleted += new EventHandler<AddressBookServiceReference.GetEntriesCompletedEventArgs>(service_GetEntriesCompleted);
            service.GetEntriesAsync();
        }

        private void listBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

        }
    }
}
